package Core.Image;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;


public class LetterImage {
	private DataOutputStream out = null;
	private DataInputStream in = null;
	private static char charBackground='.',charFont='*';
	
	public LetterImage(DataOutputStream out, DataInputStream in){
		this.out = out;
		this.in = in;
	}
	
	public String listen()throws IOException{
		String temp = this.in.readUTF();
		return temp;
	}

	public void say(String words)throws IOException{
//		System.out.println(words);
		this.out.writeUTF(words);
		this.out.flush();
	}

	
	private static final String a[][]={{"1x2","x x","xxx","x x","x x"},
            {"xx2","x x","xx{","x x","xx4"},
            {"1x2","x x","x  ","x x","3x4"},
            {"xx2","x x","x x","x x","xx4"},
            {"xxx","x  ","xxx","x  ","xxx"},
            {"xxx","x  ","xxx","x  ","x  "},
            {"1x2","x x","x  ","x3x","3x4"},
            {"x x","x x","xxx","x x","x x"},
            {"xxx"," x "," x "," x ","xxx"},
            {"xxx"," x "," x "," x ","xx "},
            {"x x","x1x","xx{","x3x","x x"},
            {"x  ","x  ","x  ","x  ","xxx"},
            {"xvx","xxx","xxx","xxx","xxx"},
            {"x2x","xxx","xxx","xxx","x3x"},
            {"1x2","x x","x x","x x","3x4"},
            {"xx2","x x","xx4","x  ","x  "},
            {"1x2","x x","x x","x x","3x{"},
            {"xx2","x x","xx{","x x","x x"},
            {"1x2","x2x","3x2","x3x","3x4"},
            {"xxx"," x "," x "," x "," x "},
            {"x x","x x","x x","xvx","3x4"},
            {"x x","x x","x x","x x"," x "},
            {"xxx","xxx","xxx","xxx","x^x"},
            {"x x","xvx","}x{","x^x","x x"},
            {"x x","x x","3x4"," x "," x "},
            {"xxx"," 1x","1x4","x4 ","xxx"}};
	public static char getCharBackground() {
		return charBackground;
	}
	public static char getCharFont() {
		return charFont;
	}
	public static void setCharBackground(char c) {
		charBackground=c;
	}
	public static void setCharFont(char c) {
		charFont=c;
	}
	public void run() {
		try {
			
			int n=Integer.parseInt(this.listen());
			int m=(n+1)>>1;
			String s=this.listen();
			int l=s.length();
			for(int j=0;j<=4;j++)
				for(int h=1;h<=n;h++) {
					String c="";
					int h1=h-1;
					int h11=h+1;
					int nh2=n-h+2;
					int nh1=n-h+1;
					int nh=n-h;
					for(int k=0;k<l;k++) if (s.charAt(k)==' ') {
						for(int x=1;x<=5;x++)
							for(int i=1;i<=n;i++)
								c+=charBackground;
					}else {
						for(int i=1;i<=n;i++)
							c+=charBackground;
						for(int x=0;x<=2;x++) {
							switch(a[s.charAt(k)-'A'][j].charAt(x)) {
								case ' ':
									for(int i=1;i<=n;i++) c+=charBackground;
									break;
								case 'x':
									for(int i=1;i<=n;i++) c+=charFont;
									break;
								case 'v':
									if (h>m)
										for(int i=1;i<=n;i++) c+=charFont;
									else {
										for(int i=1;i<=h1;i++) c+=charFont;
										for(int i=h;i<=nh1;i++) c+=charBackground;
										for(int i=nh2;i<=n;i++) c+=charFont;
									}
									break;
								case '^':
									if (h<m)
										for(int i=1;i<=n;i++) c+=charFont;
									else {
										for(int i=1;i<=nh;i++) c+=charFont;
										for(int i=nh1;i<=h;i++) c+=charBackground;
										for(int i=h11;i<=n;i++) c+=charFont;										
									}
									break;
								case '{':
									if (h>m) {
										for(int i=1;i<=h1;i++) c+=charFont;
										for(int i=h;i<=n;i++) c+=charBackground;
									}else {
										for(int i=1;i<=nh;i++) c+=charFont;
										for(int i=nh1;i<=n;i++) c+=charBackground;
									}
									break;		
								case '}':
									if (h>m) {
										for(int i=1;i<=nh1;i++) c+=charBackground;
										for(int i=nh2;i<=n;i++) c+=charFont;
									}else {
										for(int i=1;i<=h;i++) c+=charBackground;
										for(int i=h11;i<=n;i++) c+=charFont;
									}
									break;	
								case '1':
									for(int i=1;i<=nh1;i++) c+=charBackground;
									for(int i=nh2;i<=n;i++) c+=charFont;
									break;
								case '2':
									for(int i=1;i<=h1;i++) c+=charFont;
									for(int i=h;i<=n;i++) c+=charBackground;
									break;
								case '3':
									for(int i=1;i<=h;i++) c+=charBackground;
									for(int i=h11;i<=n;i++) c+=charFont;
									break;
								case '4':
									for(int i=1;i<=nh;i++) c+=charFont;
									for(int i=nh1;i<=n;i++) c+=charBackground;
									break;
							}
						}
						for(int i=1;i<=n;i++) c+=charBackground;
					}
					this.say(c + "\n");
				}

		}catch(Exception err){
			err.printStackTrace();
		}
	}
//	public static void main(String args[]) {
//		run();
//	}
}
//4
//SYSUSDCS
//........****............****....****............****............****....****............****............********................****................****........
//.......******...........****....****...........******...........****....****...........******...........*********..............******..............******.......
//......********..........****....****..........********..........****....****..........********..........**********............********............********......
//.....**********.........****....****.........**********.........****....****.........**********.........***********..........**********..........**********.....
//....****....****........****....****........****....****........****....****........****....****........****....****........****....****........****....****....
//....*****...****........****....****........*****...****........****....****........*****...****........****....****........****....****........*****...****....
//....******..****........****....****........******..****........****....****........******..****........****....****........****....****........******..****....
//....*******.****........****....****........*******.****........****....****........*******.****........****....****........****....****........*******.****....
//.....*******.............**********..........*******............****....****.........*******............****....****........****.................*******........
//......*******.............********............*******...........****....****..........*******...........****....****........****..................*******.......
//.......*******.............******..............*******..........****....****...........*******..........****....****........****...................*******......
//........*******.............****................*******.........****....****............*******.........****....****........****....................*******.....
//....****.*******............****............****.*******........****....****........****.*******........****....****........****....****........****.*******....
//....****..******............****............****..******........*****..*****........****..******........****....****........****....****........****..******....
//....****...*****............****............****...*****........************........****...*****........****....****........****....****........****...*****....
//....****....****............****............****....****........************........****....****........****....****........****....****........****....****....
//.....**********.............****.............**********..........**********..........**********.........***********..........**********..........**********.....
//......********..............****..............********............********............********..........**********............********............********......
//.......******...............****...............******..............******..............******...........*********..............******..............******.......
//........****................****................****................****................****............********................****................****........
//3
//HAPPYNEWYEAR
//...***...***.........***.........******.........******.........***...***......***...***......*********......*********......***...***......*********.........***.........******......
//...***...***........*****........*******........*******........***...***......****..***......*********......*********......***...***......*********........*****........*******.....
//...***...***.......*******.......********.......********.......***...***......*****.***......*********......*********......***...***......*********.......*******.......********....
//...***...***......***...***......***...***......***...***......***...***......*********......***............*********......***...***......***............***...***......***...***...
//...***...***......***...***......***...***......***...***......***...***......*********......***............*********......***...***......***............***...***......***...***...
//...***...***......***...***......***...***......***...***......***...***......*********......***............*********......***...***......***............***...***......***...***...
//...*********......*********......********.......********........*******.......*********......*********......*********.......*******.......*********......*********......********....
//...*********......*********......*******........*******..........*****........*********......*********......*********........*****........*********......*********......*******.....
//...*********......*********......******.........******............***.........*********......*********......*********.........***.........*********......*********......********....
//...***...***......***...***......***............***...............***.........*********......***............*********.........***.........***............***...***......***...***...
//...***...***......***...***......***............***...............***.........*********......***............*********.........***.........***............***...***......***...***...
//...***...***......***...***......***............***...............***.........*********......***............*********.........***.........***............***...***......***...***...
//...***...***......***...***......***............***...............***.........***.*****......*********......*********.........***.........*********......***...***......***...***...
//...***...***......***...***......***............***...............***.........***..****......*********......****.****.........***.........*********......***...***......***...***...
//...***...***......***...***......***............***...............***.........***...***......*********......***...***.........***.........*********......***...***......***...***...
