package Core.Image;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

//»­³ö»ýÄ¾Æ½Ãæ¸ß¶ÈÍ¼¶ÔÓ¦µÄÁ¢ÌåÍ¼
//ÊäÈëÐÐÊýmºÍÁÐÊýn
//Ö®ºóÊäÈëÒ»¸ömÐÐnÁÐµÄ¾ØÕó£¬±íÃ÷Ã¿Ò»¸öÎ»ÖÃµÄ¸ß¶È
public class Stereogram {
	private DataOutputStream out = null;
	private DataInputStream in = null;
	private static int m,n,h,w;
	private static int[][] a;
	private static char[][] bit;
	
	public Stereogram(DataOutputStream out, DataInputStream in) {
		this.out = out;
		this.in = in;
	
	}
	public String listen()throws IOException{
		String temp = this.in.readUTF();
		return temp;
	}

	public void say(String words)throws IOException{
//		System.out.println(words);
		this.out.writeUTF(words);
		this.out.flush();
	}

	private void init() throws NumberFormatException, IOException {
		
		m=Integer.parseInt(this.listen());
		n=Integer.parseInt(this.listen());
		a=new int[m+2][n+2];
		int mm=0,max=0;
		for(int i=1;i<=m;i++)
			for(int j=n;j>=1;j--) {
				a[i][j]=Integer.parseInt(this.listen());
				mm=3*(a[i][j]+1)-2*(i-1);
				if (mm>max)
					max=mm;
			}
		h=max+2*(m-1);
		w=4*n+2*m+1;
		bit=new char[h+2][w+2];
		for(int i=1;i<=h;i++)
			for(int j=1;j<=w;j++)
				bit[i][j]='.';
		
	}
	
	
	private void draw(int x,int y) {
		int k=a[x][y];
		if (k==0) return;
		int i=1+2*(m-x);
		int j=i+4*(n-y);
		while (k>0) {
			k--;
			bit[i][j]='+';
			bit[i][j+1]='-';
			bit[i][j+2]='-';
	        bit[i][j+3]='-';
	        bit[i][j+4]='+';
	        bit[i+1][j]='|';
	        bit[i+1][j+1]=' ';
	        bit[i+1][j+2]=' ';
	        bit[i+1][j+3]=' ';
	        bit[i+1][j+4]='|';
	        bit[i+1][j+5]='/';
	        bit[i+2][j]='|';
	        bit[i+2][j+1]=' ';
	        bit[i+2][j+2]=' ';
	        bit[i+2][j+3]=' ';
	        bit[i+2][j+4]='|';
	        bit[i+2][j+5]=' ';
	        bit[i+2][j+6]='+';
	        bit[i+3][j]='+';
	        bit[i+3][j+1]='-';
	        bit[i+3][j+2]='-';
	        bit[i+3][j+3]='-';
	        bit[i+3][j+4]='+';
	        bit[i+3][j+5]=' ';
	        bit[i+3][j+6]='|';
	        bit[i+4][j+1]='/';
	        bit[i+4][j+2]=' ';
	        bit[i+4][j+3]=' ';
	        bit[i+4][j+4]=' ';
	        bit[i+4][j+5]='/';
	        bit[i+4][j+6]='|';
	        bit[i+5][j+2]='+';
	        bit[i+5][j+3]='-';
	        bit[i+5][j+4]='-';
	        bit[i+5][j+5]='-';
	        bit[i+5][j+6]='+';
	        i+=3;
		}
	}
	private void work() {
		for(int i=1;i<=m;i++)
			for(int j=n;j>=1;j--)
				draw(i,j);	
	}
	private void printImage() throws IOException {
		for(int i=h;i>=1;i--) {
			for(int j=1;j<=w;j++)
				this.say("" + bit[i][j]);
			this.say("\n");
		}
	}
	public void run() {
		try {
			init();
			work();
			printImage();
		}catch(Exception err) {
			err.printStackTrace();
		}
	}
//	public static void main(String args[]) {
//		run();
//	}
}
//4 4
//1 2 0 3
//4 2 1 0
//1 1 2 0
//0 1 1 0
//......+---+..............
//...../   /|.........+---+
//....+---+ |......../   /|
//....|   | +.......+---+ |
//....|   |/|.+---+.|   | +
//....+---+ |/   /|.|   |/|
//....|   | +---+ |.+---+ |
//....|   |/   /| +.|   | +
//....+---+---+---+.|   |/|
//....|   |  /   /|-+---+ |
//....|   | +---+ |/|   | +
//....+---+-|   | + |   |/.
//.../   /  |   |/| +---+..
//..+---+---+---+ |/.......
//..|  /   /   /| +........
//..| +---+---+ |/.........
//..+-|   |   | +..........
//....|   |   |/...........
//....+---+---+............
//5 5
//1 1 1 1 1
//1 2 2 2 1
//1 2 3 2 1
//1 2 2 2 1
//1 1 1 1 1
//..............+---+............
//............+/   /|-+---+......
//..........+/+---+ |/   /|-+---+
//........./+-|   | +---+ |/   /|
//........+/  |   |/   /| +---+ |
//......./+---+---+---+ |/   /| +
//......+/   /   /   /| +---+ |/.
//...../+---+---+---+ |/   /| +..
//....+-|   |   |   | +---+ |/...
//.../  |   |   |   |/   /| +....
//..+---+---+---+---+---+ |/.....
//./   /   /   /   /   /| +......
//+---+---+---+---+---+ |/.......
//|   |   |   |   |   | +........
//|   |   |   |   |   |/.........
//+---+---+---+---+---+..........
//11 11
//1 1 1 1 1 1 1 1 1 1 1
//1 2 2 2 2 2 2 2 2 2 1
//1 2 3 3 3 3 3 3 3 2 1
//1 2 3 4 4 4 4 4 3 2 1
//1 2 3 4 5 5 5 4 3 2 1
//1 2 3 4 5 6 5 4 3 2 1
//1 2 3 4 5 5 5 4 3 2 1
//1 2 3 4 4 4 4 4 3 2 1
//1 2 3 3 3 3 3 3 3 2 1
//1 2 2 2 2 2 2 2 2 2 1
//1 1 1 1 1 1 1 1 1 1 1
//................................+---+..............................
//..............................+/   /|-+---+........................
//............................+/+---+ |/   /|-+---+..................
//..........................+/+-|   | +---+ |/   /|-+---+............
//........................+/+/  |   |/   /| +---+ |/   /|-+---+......
//......................+/+/+---+---+---+ |/   /| +---+ |/   /|-+---+
//...................../+/+/   /   /   /| +---+ |/   /| +---+ |/   /|
//....................+/+/+---+---+---+ |/   /| +---+ |/   /| +---+ |
//.................../+/+-|   |   |   | +---+ |/   /| +---+ |/   /| +
//..................+/+/  |   |   |   |/   /| +---+ |/   /| +---+ |/.
//................./+/+---+---+---+---+---+ |/   /| +---+ |/   /| +..
//................+/+/   /   /   /   /   /| +---+ |/   /| +---+ |/...
//.............../+/+---+---+---+---+---+ |/   /| +---+ |/   /| +....
//..............+/+-|   |   |   |   |   | +---+ |/   /| +---+ |/.....
//............./+/  |   |   |   |   |   |/   /| +---+ |/   /| +......
//............+/+---+---+---+---+---+---+---+ |/   /| +---+ |/.......
//.........../+/   /   /   /   /   /   /   /| +---+ |/   /| +........
//..........+/+---+---+---+---+---+---+---+ |/   /| +---+ |/.........
//........./+-|   |   |   |   |   |   |   | +---+ |/   /| +..........
//........+/  |   |   |   |   |   |   |   |/   /| +---+ |/...........
//......./+---+---+---+---+---+---+---+---+---+ |/   /| +............
//......+/   /   /   /   /   /   /   /   /   /| +---+ |/.............
//...../+---+---+---+---+---+---+---+---+---+ |/   /| +..............
//....+-|   |   |   |   |   |   |   |   |   | +---+ |/...............
//.../  |   |   |   |   |   |   |   |   |   |/   /| +................
//..+---+---+---+---+---+---+---+---+---+---+---+ |/.................
//./   /   /   /   /   /   /   /   /   /   /   /| +..................
//+---+---+---+---+---+---+---+---+---+---+---+ |/...................
//|   |   |   |   |   |   |   |   |   |   |   | +....................
//|   |   |   |   |   |   |   |   |   |   |   |/.....................
//+---+---+---+---+---+---+---+---+---+---+---+......................